"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _solidLogic = require("solid-logic");
var UI = _interopRequireWildcard(require("solid-ui"));
var panes = _interopRequireWildcard(require("pane-registry"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
/*      View argument Pane
**
**  This pane shows a position and optionally the positions which
** support or oppose it.
** @@ Unfinsihed.
** Should allow editing the data too

*/
// console.log('@@@ argument pane icon at ' + (module.__dirname || __dirname) + '/icon_argument.png')
var _default = exports["default"] = {
  icon: (module.__dirname || __dirname) + '/icon_argument.png',
  // @@ fix fro mashlib version

  name: 'argument',
  label: function label(subject) {
    var kb = _solidLogic.store;
    var t = kb.findTypeURIs(subject);
    if (t[UI.ns.arg('Position').uri]) return 'Argument';
    return null;
  },
  // View the data in a file in user-friendly way
  render: function render(subject, dom) {
    var outliner = panes.getOutliner(dom);
    var kb = _solidLogic.store;
    var arg = UI.ns.arg;
    subject = kb.canon(subject);
    // var types = kb.findTypeURIs(subject)

    var div = dom.createElement('div');
    div.setAttribute('class', 'argumentPane');

    // var title = kb.any(subject, UI.ns.dc('title'))

    var comment = kb.any(subject, UI.ns.rdfs('comment'));
    if (comment) {
      var para = dom.createElement('p');
      para.setAttribute('style', 'margin-left: 2em; font-style: italic;');
      div.appendChild(para);
      para.textContent = comment.value;
    }
    div.appendChild(dom.createElement('hr'));
    var plist = kb.statementsMatching(subject, arg('support'));
    outliner.appendPropertyTRs(div, plist, false);
    div.appendChild(dom.createElement('hr'));
    plist = kb.statementsMatching(subject, arg('opposition'));
    outliner.appendPropertyTRs(div, plist, false);
    div.appendChild(dom.createElement('hr'));
    return div;
  }
}; // ends
//# sourceMappingURL=argumentPane.js.map